###################################
# A small sed script to replace   #
# Wiki links to local one         #
###################################
# sed -i -f stored_replacements.sed file.html
#
# note the different (default) regexpr !!!
# summarised: + is + ? is ? ( is ( { is { → all no expressions!
#   (..) → \(\)    reference 
#   ?    → \?      0 or 1
#   .+   → .\+     1 or many
#   .*   → .*      0 or many
#   [..] → [..]    character definition range
#   {..} → \{..\}
#### single line matches
# s → search, g → global scope (multiple replacements)
# s/search/replace/g
#### match with address
#   /address/s/search/replace/g
# NOT-match or everything except “address”
#   /address/!s/search/replace/g
#### match with newline (N appends \n to the pattern)
#   /searchpattern line 1/N;/searchpattern line 2/{
#     # some thing ONLY with the found pattern!
#     s/search/replace/g
#   }

# replace Wikilink → local link
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_rotundifolia_130405.jpg\|Datei:Drosera_rotundifolia_130405.jpg\)\1@href=\1media/420px-Drosera_rotundifolia_130405.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_intermedia0.jpg\|Datei:Drosera_intermedia0.jpg\)\1@href=\1media/420px-Drosera_intermedia0.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3AAldrovandaVesiculosaHabit.jpg\|Datei:AldrovandaVesiculosaHabit.jpg\)\1@href=\1media/420px-AldrovandaVesiculosaHabit.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3AAldrovanda_vesiculosa_whorl_of_leaves_from_Prof._Cohn_%28Darwin_1896%2C_fig_13_upper%2C_p_323%29.png\|Datei:Aldrovanda_vesiculosa_whorl_of_leaves_from_Prof._Cohn_(Darwin_1896,_fig_13_upper,_p_323).png\)\1@href=\1media/420px-Aldrovanda_vesiculosa_whorl_of_leaves_from_Prof._Cohn_(Darwin_1896,_fig_13_upper,_p_323).png.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Droseraceae_%28Deutschland%29\|Droseraceae_(Deutschland)\)\1@href=\1Droseraceae_(Deutschland).html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Droseraceae\|Droseraceae\)\1@href=\1Droseraceae.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Aldrovanda\|Aldrovanda\)\1@href=\1Aldrovanda.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3AInsectivorous_Plants_Figure_1.png\|Datei:Insectivorous_Plants_Figure_1.png\)\1@href=\1media/420px-Insectivorous_Plants_Figure_1.png.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_rotundifolia_leaf1.jpg\|Datei:Drosera_rotundifolia_leaf1.jpg\)\1@href=\1media/420px-Drosera_rotundifolia_leaf1.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_rotundifolia_inflorescence_Darwiniana.jpg\|Datei:Drosera_rotundifolia_inflorescence_Darwiniana.jpg\)\1@href=\1media/420px-Drosera_rotundifolia_inflorescence_Darwiniana.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_rotundifolia_bluete.jpeg\|Datei:Drosera_rotundifolia_bluete.jpeg\)\1@href=\1media/420px-Drosera_rotundifolia_bluete.jpeg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_rotundifolia_frucht.jpeg\|Datei:Drosera_rotundifolia_frucht.jpeg\)\1@href=\1media/420px-Drosera_rotundifolia_frucht.jpeg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ANsr-slika-068.png\|Datei:Nsr-slika-068.png\)\1@href=\1media/420px-Nsr-slika-068.png.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3AD_D_rotundifolia.png\|Datei:D_D_rotundifolia.png\)\1@href=\1media/315px-D_D_rotundifolia.png.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Drosera_%28Mitteleuropa%29\|Drosera_(Mitteleuropa)\)\1@href=\1Drosera_(Mitteleuropa).html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_anglica-04-Lengener_Meer-2003.jpg\|Datei:Drosera_anglica-04-Lengener_Meer-2003.jpg\)\1@href=\1media/420px-Drosera_anglica-04-Lengener_Meer-2003.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_anglica_habit.jpg\|Datei:Drosera_anglica_habit.jpg\)\1@href=\1media/420px-Drosera_anglica_habit.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_anglica_Darwiniana.jpg\|Datei:Drosera_anglica_Darwiniana.jpg\)\1@href=\1media/420px-Drosera_anglica_Darwiniana.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_anglica_ne4.jpg\|Datei:Drosera_anglica_ne4.jpg\)\1@href=\1media/420px-Drosera_anglica_ne4.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_anglica_flower_Darwiniana.jpg\|Datei:Drosera_anglica_flower_Darwiniana.jpg\)\1@href=\1media/420px-Drosera_anglica_flower_Darwiniana.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ANsr-slika-069.png\|Datei:Nsr-slika-069.png\)\1@href=\1media/420px-Nsr-slika-069.png.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADeutschland_Drosera_anglica.png\|Datei:Deutschland_Drosera_anglica.png\)\1@href=\1media/315px-Deutschland_Drosera_anglica.png.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_anglica_alpina-02-Kaernten-2008-Thomas_Huntke.jpg\|Datei:Drosera_anglica_alpina-02-Kaernten-2008-Thomas_Huntke.jpg\)\1@href=\1media/420px-Drosera_anglica_alpina-02-Kaernten-2008-Thomas_Huntke.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_x_obovata-Lengener_Meer-2004.jpg\|Datei:Drosera_x_obovata-Lengener_Meer-2004.jpg\)\1@href=\1media/420px-Drosera_x_obovata-Lengener_Meer-2004.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3AMittlerer_Sonnentau_i_d_Bl%C3%BCte.JPG\|Datei:Mittlerer_Sonnentau_i_d_Blüte.JPG\)\1@href=\1media/420px-Mittlerer_Sonnentau_i_d_Bluete.JPG.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_intermedia_ne1.jpg\|Datei:Drosera_intermedia_ne1.jpg\)\1@href=\1media/420px-Drosera_intermedia_ne1.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera_intermedia_flower_Darwiniana.jpg\|Datei:Drosera_intermedia_flower_Darwiniana.jpg\)\1@href=\1media/420px-Drosera_intermedia_flower_Darwiniana.jpg.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADrosera-Enallagma.JPG\|Datei:Drosera-Enallagma.JPG\)\1@href=\1media/420px-Drosera-Enallagma.JPG.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Datei%3ADeutschland_Drosera_intermedia.png\|Datei:Deutschland_Drosera_intermedia.png\)\1@href=\1media/315px-Deutschland_Drosera_intermedia.png.html\1@g
s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\(Bestimmungsschl%C3%BCssel_f%C3%BCr_die_Gattung_Drosera_in_Mitteleuropa_%28Thomas_Huntke%29\|Bestimmungsschlüssel_für_die_Gattung_Drosera_in_Mitteleuropa_(Thomas_Huntke)\)\1@href=\1Bestimmungsschluessel_fuer_die_Gattung_Drosera_in_Mitteleuropa_(Thomas_Huntke).html\1@g
# add normal site links with href title 
  s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\([^'"]\+\)\1\( *title *=*\1[^'"]\+\1 *>\)@href=\1http://offene-naturfuehrer.de/web/\3\1 class=\1external\1 target=\1_blank\1\4@g

# add class="external" target="_blank" also to achors with title="…" class="mw-redirect"
  /<a[^>]\+href *= *\(['"]\)\(\/web\/\|http:\/\/offene-naturfuehrer.de\/web\/\)[^'"]\+\1[^>]\+title *= *\1[^'"]\+\1[^>]*class=\1mw-redirect\1[^>]*>/{
    # do something with the found pattern
    s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\([^'"]\+\)\1@href=\1http://offene-naturfuehrer.de/web/\3\1@g
    s@class *= *\(['"]\)mw-redirect\1@class=\1mw-redirect external\1 target=\1_blank\1@g
  }
# add class="image" + title or not
  /<a[^>]\+href *= *\(['"]\)\(\/web\/\|http:\/\/offene-naturfuehrer.de\/web\/\)[^'\"]\+\1[^>]\+class=\1image\1[^>]*>/{
    # do something with the found pattern
    s@href *= *\(['"]\)\(/web/\|http://offene-naturfuehrer.de/web/\)\([^'"]\+\)\1@href=\1http://offene-naturfuehrer.de/web/\3\1@g
    s@class *= *\(['"]\)image\1@& target=\1_blank\1@g
  }
# add class="new" → class="new external"
  /<a[^>]\+href *= *\(['"]\)\(\/w\/\|http:\/\/offene-naturfuehrer.de\/w\/\)[^'"]\+\1[^>]\+class=\1new\1[^>]*title *= *\1[^'"]\+\1[^>]*>/{
    # do something with the found pattern
    s@href *= *\(['"]\)\(/w/\|http://offene-naturfuehrer.de/w/\)\([^'"]\+\)\1@href=\1http://offene-naturfuehrer.de/w/\3\1@g
    s@class *= *\(['"]\)new\1@class=\1new external\1 target=\1_blank\1@g
  }
  # remove do-not-replace-here from anchors
  /<a[^>]\+href *= *\(['"]\)[^'"]*do-not-replace-here[^'"]*\1[^>]*>/{
    # do something with the found pattern
    s@do-not-replace-here@@g
  }
